// cluster.c
# include "alfa.h"

# define maxdim 10
# define maxclassi 20
# define maxcardX 200

typedef struct {char *Nome; double a[maxdim];} dato;
typedef struct {int colori[maxcardX]; double rendimento;} partizione;

static void calcolarendimenti(), eliminacommenti(), impostapuntatori(),
  incroci(), mutazioni(), nuovi(), ordina(), ottimizzazione(), raccoglidati(),
  utente();
static int migliore(), visualizza();
static double g();

static int cardX,classi,dim;
static dato X[maxcardX];
static char datigrezzi[80000];
static char *Titoli[maxdim+1];
static partizione partizioni[40],*Puntatori[41];
////////////////////////////////////////////////////////
void comuni()
{dato x; int k,j; char *A,a[100];
sprintf(a,"Dati/"); printf("Nome del file: "); input(a+5,40);
if (caricafile(a,datigrezzi,79900)!=1) return;
printf("Numero delle classi: "); input(a,40); classi=atoi(a);
if (classi>maxclassi) return;
for (A=datigrezzi;*A;A++); *A='\n'; *(++A)=0; // sicurezza
raccoglidati();
printf("\n%-15s  ",Titoli[0]);
for (j=1;j<=dim;j++) printf("%s  ",Titoli[j]); printf("\n");
for (k=0;k<cardX;k++)
{x=X[k]; printf("\n%-15s  ",x.Nome);
for (j=1;j<=dim;j++) printf("%*.0f  ",strlen(Titoli[j]),x.a[j-1]);}
printf("\n"); ottimizzazione(); utente();}

////////////////////////////////////////////////////////
static void calcolarendimenti()
{int k;
for (k=0;k<40;k++) Puntatori[k]->rendimento=g(Puntatori[k]);}

static void eliminacommenti()
{char *D,*E;
for (D=datigrezzi;;) {D=strchr(D,'#'); if (D==0) return;
E=strchr(D,'\n'); for (;D<E;D++) *D=' '; D++;}}

static void impostapuntatori()
{int k;
for (k=0;k<40;k++) Puntatori[k]=&partizioni[k]; Puntatori[k]=0;}

static void incroci()
{int k,i,c; partizione p,q,*P,*Q;
for (k=0;k<38;k+=2) {P=Puntatori[k]; p=*P; Q=Puntatori[k+1]; q=*Q;
for (i=0;i<cardX;i++) if (dado(2)==1)
{c=p.colori[i]; p.colori[i]=q.colori[i]; q.colori[i]=c;}
p.rendimento=g(&p); q.rendimento=g(&q);
if ((migliore(&p,P)&&migliore(&p,Q))||(migliore(&q,P)&&migliore(&q,Q)))
{*P=p; *Q=q;}}}

static void mutazioni()
{int k,i,m; partizione p,*P;
for (k=0;k<40;k++) {P=Puntatori[k]; p=*P; m=cardX/dado(4);
for (i=0;i<cardX;i++) if (dado(m)==1) p.colori[i]=dado(classi)-1;
p.rendimento=g(&p); if (migliore(&p,P)) *P=p;}}

static void nuovi (int a, int b)
{int k,j;
for (k=a;k<=b;k++) for (j=0;j<cardX;j++)
Puntatori[k]->colori[j]=dado(classi)-1;}

static void ordina()
{quicksort(Puntatori,migliore);}

static void ottimizzazione()
{int t,dt=10,ancora;
impostacasuali(); impostapuntatori(); nuovi(0,39);
for (t=1,ancora=1;;t++) {calcolarendimenti(); ordina();
if (t%dt==0) ancora=visualizza(t); if (ancora==0) break;
nuovi(30,39); incroci(); mutazioni();}}

static void raccoglidati()
{int k,j,p; char *D,*E,*F;
eliminacommenti();
// Rileviamo titoli e dim:
for (D=datigrezzi,E=strchr(D,'\n'),k=0;;k++)
{p=strspn(D," "); D+=p; if (D>=E) break;
F=strpbrk(D," \n"); *F=0; Titoli[k]=D; D=F+1;}
dim=k-1; // Titolo[0] e' una descrizione, ad es. comuni
// Raccogliamo i dati:
for (k=0;k<maxcardX;k++)
{p=strspn(D," \n"); D+=p; E=strchr(D,':');
if (E==0) goto fine;
*E=0; X[k].Nome=D; D=E+1;
for (j=0;j<dim;j++) {p=strspn(D," \n"); D+=p;
E=strpbrk(D," \n"); *E=0; X[k].a[j]=atof(D); D=E+1;}}
fine: cardX=k;}

static void utente()
{char a[40],*A,b[2]; partizione p; int i;
printf("Prova una partizione: "); input(a,15);
if (strlen(a)!=cardX) return; b[1]=0;
for (A=a,i=0;*A;A++,i++) {b[0]=*A; p.colori[i]=atoi(b)-1;}
printf("%.2f\n",g(&p));}

static int migliore (partizione *A, partizione *B)
{return (A->rendimento<B->rendimento);}

static int visualizza (int t)
{char a[100]; partizione *P=Puntatori[0]; int k,j;
printf("\nGenerazione %d, Rendimento %.2f:\n",t,P->rendimento);
for (k=0;k<classi;k++) {printf("\nGruppo %d: ",k+1);
for (j=0;j<cardX;j++) if (P->colori[j]==k) printf("%s ",X[j].Nome);}
printf("\n\nVuoi continuare? "); input(a,40);
if (us(a,"no")) return 0; return 1;}

static double g (partizione *P)
{int c[maxclassi],k,j,i;
double b[maxclassi][maxdim],delta[maxclassi],diff,val;
// c[k] e' il numero degli elementi della k-esima classe
// b[k][j] e' la j-esima componente del suo baricentro
// Calcoliamo il numero di elementi per ogni classe:
for (k=0;k<classi;k++) c[k]=0;
for (i=0;i<cardX;i++) c[P->colori[i]]++;
for (k=0;k<classi;k++) if (c[k]==0) return 10e20;
// Calcoliamo i baricentri:
for (k=0;k<classi;k++) for (j=0;j<dim;j++) b[k][j]=0;
for (i=0;i<cardX;i++) {k=P->colori[i];
  for (j=0;j<dim;j++) b[k][j]+=X[i].a[j];}
for (k=0;k<classi;k++) for (j=0;j<dim;j++) b[k][j]/=c[k];
// Calcoliamo delta per ogni classe:
for (k=0;k<classi;k++) delta[k]=0;
for (i=0;i<cardX;i++) {k=P->colori[i];
  for (j=0;j<dim;j++) {diff=X[i].a[j]-b[k][j]; delta[k]+=diff*diff;}}
// Calcoliamo il valore di g
for (val=0,k=0;k<classi;k++) val+=delta[k]; return val;}
