// matematica.c
# include "alfa.h"

int mcd (int a, int b)
{if (a<0) a=-a; if (b<0) b=-b;
if (b==0) return a; return mcd(b,a%b);}

int mcdit (int a, int b)
{int r;
if (a<0) a=-a; if (b<0) b=-b;
for (;b;) {r=a%b; a=b; b=r;} return a;}

int mcdb (int a, int b)
{int apari,bpari;
return a<0? mcdb(-a,b) : b<0? mcdb(a,-b) :
a==0? b : b==0? a :
(apari=(a%2==0), bpari=(b%2==0),
apari&&bpari? 2*mcdb(a/2,b/2) :
apari? mcdb(a/2,b) : bpari? mcdb(a,b/2) :
a<b? mcdb(b,a) : mcdb((a-b)/2,b));}

double bin(int n, int k)
{double num,den,i,j;
for (num=1,den=1,i=n,j=1;j<=k;i--,j++)
{num*=i; den*=j;} return num/den;}

double fattoriale (int n)
{double f; int k;
for (f=1,k=1;k<=n;k++) f*=k; return f;}

double fib1 (int n)
{double a,b,c; int k;
if (n<=1) return 1;
for (a=b=1,k=0;k<n;k++) {c=a; a=a+b; b=c;} return a;}

double fib2 (int n)
{if (n<=1) return 1;
return fib2(n-1)+fib2(n-2);}

void fib3 (int n, double *X, double *Y)
{double x,y;
if (n==0) {*X=1; *Y=0;} else
{fib3(n-1,&x,&y); *X=x+y; *Y=x;}}

coppia fib4 (int n)
{coppia u,z;
if (n==0) {z.x=1; z.y=0;} else
{u=fib4(n-1); z.x=u.x+u.y; z.y=u.x;}
return z;}

double mediana (double *A, int n)
{double *B=(double*)malloc((n+1)*sizeof(double)),med; int k;
for (k=0;k<=n;k++) B[k]=A[k];
quicksortpernumeri(B,0,n,minore);
if (n%2==0) med=B[n/2]; else med=(B[(n-1)/2]+B[(n+1)/2])/2;
free(B); return med;}

double mrussa (int n, double x)
{double s;
for (s=0;n;) if (n%2) {s+=x; n--;}
else {x+=x; n/=2;} return s;}

double mrussaric (int n, double x)
{if (n%2) return x+mrussa(n-1,x);
if (n>0) return mrussa(n/2,x+x); return 0;}

double potenza (double x, int n)
{double p;
for (p=1;n;) if (n%2) {p*=x; n--;}
else {x*=x; n/=2;} return p;}

double potenzaric (double x, int n)
{if (n%2) return x*potenza(x,n-1);
if (n>0) return potenza(x*x,n/2); return 1;}

double sgn (double x)
{if (x>0) return 1;
if (x<0) return -1; return 0;}

double stirling2 (int n, int k)
{if (n==0) if (k==0) return 1; else return 0; else
if (k==0) return 0;
else return stirling2(n-1,k-1)+k*stirling2(n-1,k);}

void zero (double (*f)(), double a, double b,
  double epsilon, double *A, double *B)
{double c,x,fa,fb,fx;
if (a>b) {c=a; a=b; b=c;}
for (;b-a>=epsilon;)
{x=(a+b)/2; fx=f(x); if (fx==0) {a=b=x; break;}
fa=f(a); fb=f(b);
if (sgn(fa)==sgn(fx)) a=x; else b=x;}
*A=a; *B=b;}
